$Id$

urjtag-2021.03

 * Require Python 3
 * Cable/J-Link: Dynamically search for usb endpoints
 * Support for Altera MAX V 5M1270Z
 * Fix FT2232 cables
 * Fix GCC 10 build error on UrjtagError declaration
 * Use \\ path separator on MINGW
 * Define __USE_MINGW_ANSI_STDIO before include stdio.h
 * compile error fix

urjtag-2019.12

 * Disambiguate part
 * vhdl functions shouldn't know anything about part
 * Added an empty data/0/PARTS for further JEP106 support
 * Added an empty data/amd/PARTS as reservation for AMD
 * minor data/MANUFACTURERS update
 * data/MANUFACTURERS got update information
 * git log hash as version number
 * src/bus/ahbjtag.c: New file. Implements bus driver for GRLIB AHBJTAG core.
 * Define stepping 0 for Xilinx xc6slx75 FPGA
 * Applied Python3 binding fix reported on SF forum
 * Removed spurious '#undef DEBUG' from two src/bus/*.c files
 * Removed editor hints from src/bus/*.c
 * Removed '$Id$' markers for src/bus/*.c

urjtag-2018.09

 * Added J-Link interface select, closes bug#127
 * Prefix all REG_* with BFIN_REG, closed bug#119

urtjag-2018.06

    * Enhancement#123 JTAGv3 and v5 cables driver
    * Document the 0x to enforce hexadecimal, closes bug#112
    * Support ixp425 stepping B1, closes bug#111
    * Code clean-up: remove double const keywords.
    * LIBFTD2XX for x86_64*cygwin is not in i386 directory so use amd64
    * pull in all required libraries in python setup.py
    * FreeBSD libgpio support code. FreeBSD 11 or later.
      jtag> cable bsdgpio tdi=18 tdo=17 tms=19 tck=20
    * fix error message on PPISCTRL
    * Allow python bindings to be built using VPATH.

urtjag-2017.10

    * First release since a long time
    * Switched from sequential version number to date related version number

urjtag-0.10

    * Major internal improvements
      - Flash write/program API function now operates on a buffer instead
        of single bytes/words. Required for the multi-byte write mode.
        (Arnim Laeuger)
      - Limit maximum number of bytes queued for usbconn based cables.
        Reduces the requested amount of memory for SVF runtest (Kolja Waschk)
      - Command and methods to access JTAG signals directly, including
        TRST and SRST (Sebastian Hesselbarth, Kolja Waschk, Arnim Laeuger)
    * Improvements to the build system
      - Several updates for Windows build compatability (Mike Frysinger)
      - CPP include strategy sanitized (Mike Frysinger)
      - Resolved formatting/printing mismatches (Mike Frysinger)
      - bsdl2jtag program replaced by wrapper script (Arnim Laeuger)
      - Man page updates (Uwe Hermann)
    * Updates to the jtag command shell
      - New usleep command (Stanislav Sinyagin)
      - Added instruction parameter to the print command (Hartley Sweeten)
      - Added ref_freq parameter to the svf command (Arnim Laeuger)
      - New pod command (Kolja Waschk)
      - Added noverify parameter to the flashmem command (Jeff Wittrock)
    * Updates to the SVF player
      - Optional reference frequency (Arnim Laeuger)
      - Fix compare TDO flaw (Kolja Waschk)
      - Fix progress indicator visibility (William)
      - Add pass/fail report for progress reporting (Arnim Laeuger)
    * New and updated bus drivers
      - Support BCM6348/EJTAG 3.1 (by Andy Potter/livebox)
      - Fixed address mode behvavior of prototype driver (Arnim Laeuger)
      - Support foe EJTAG in DMA mode (Julien Aube)
      - Added Goepel Boundary Scan Coach (Markus Schneider)
      - Added additional address decoding for mpc5200 (Jeff Wittrock)
      - General fix for part descriptions containing initbus (Arnim Laeuger)
      - Support multiplexed bus operation for mpc5200 (Jon Smirl)
    * New and updated cable drivers
      - New FT2232 based cable ARM-USB-OCD TINY (Sebastian Hesselbarth)
      - Parport calibration loop is more tolerant (Arnim Laeuger)
      - Technology Systems TS-7800 support (Catalin Ionescu)
      - New FT2232 based cable TinCanTools Flyswatter (Mark Norman)
      - New FT2232 based cable BFIN-UJTAG/gnICE+ (Michael Hennerich)
      - New Analog Devices ICE100B cable (Paula R. Bertrand)
      - Added detection of InpOut32.dll and usage for I/O port access even
        under Vista (Kolja Waschk)
      - FT2232 MPSSE buffer increased to mitigate performance decrease (Arnim
        Laeuger)
      - Keep FTDI based JTAG dongles in current mode during initialization
        (Holger Schurig)
      - New FT2232 based cable UsbScarab2 (Tomek Cedro)
    * Updated flash drivers
      - Spansion S92GL chips added (Arnim Laeuger)
      - Multi-byte write mode support for Intel and AMD chips (Arnim Laeuger)
      - MX29LV640B recognition (Julien Aube)
      - Fixed memory corruption from jedec code (Jon Smirl)
      - Fix and polish flasherase implementation (Jeff Wittrock, Arnim Laeuger)
    * Added new JTAG declarations for
      - New steppings for BF527, BF533, BF548 (Mike Frysinger)
      - New IDs for BF534 and BF548M (Mike Frysinger)
      - Addes stepping for MPC5200B (Jeff Wittrock)
      - Analog Devices Blackfin BF518 (Mike Frysinger)
      - Atheros AR2313 flash access (snowwiehua)
      - Atmel AVR32 clarifications (Holger Schurig)
      - Broadcom BCM6358 / neufbox4 (Julien Aube)
      - Lattice LC4064ZC (Catalin Ionescu)
      - Lattice LFEC2-12E (Catalin Ionescu)
      - Marvell 88E1118, 88F5182-A2 (Catalin Ionescu)
      - Texas Instruments TNETV1060, TNETV1061 (Kenny)
    * Updated documentation

urjtag-0.9

	* Completely rewritten BSDL parser, making it better maintainable,
		extendable, and also adding support for IEEE 1532 extensions 
        (Arnim Laeuger)
    * Major internal improvements
      - Most if not all internal functions now take a pointer to the
        chain configuration data as an argument, instead of using a 
        global "chain" variable. Needed for use as a library (Jie Zhang)
      - Generally UrJTAG uses less global variables now (all)
      - Added new "link driver" layer where previously only parport
        was known; now there's a separate subsystem for USB cables,
        named "usbconn". Due to the switch, some "cable" command 
        arguments for USB cables changed! (Arnim Laeuger, Kolja Waschk)
    * Improvements to the build system
      - Cable and link driver selection during ./configure (Arnim Laeuger)
      - Fix building out of tree (Mike Frysinger)
      - Support run-time relocatable UrJTAG (Mike Frysinger)
      - Many improvements for building on Windows and generally on
        other platforms (by Mike Frysinger)
      - Support building under Mac OS X (Ville Voipio)
      - Some initial work to support building in MinGW (Kolja Waschk)
    * Updates to the jtag command shell
      - Allow to disable startup message and quit upon EOF (Mike Frysinger)
      - Allow customization of jtag prompt via env variable (Mike Frysinger)
      - Don't add duplicate history lines (Uwe Bonnes)
      - Fixes to handling of the "frequency" command (many contributors)
      - Fix quitting when not using readline (Mike Frysinger)
      - Fix some irritating warning messages even if there was nothing wrong
      - New "idcode" command (Uwe Bonnes)
    * Updates to the SVF player
      - Added progress indicator (Steve Franks)
      - Fix for RUNTEST command with SEC argument (Arnim Laeuger)
      - Read TDO data from instruction shift (Arnim Laeuger)
    * New and updated bus drivers 
      - General cleanup and malloc/free issues fixed (Hartley Sweeten)
      - Added avr32 bus driver (Gabor Juhos)
      - Added bf526,bf527,bf538 and bf548_ezkit bus driver (Jie Zhang)
      - Added fjmem bus driver (A. Laeuger)
      - Add 32 bit bus support for mpc824x (Eugene Boldenkov)
    * New and updated cable drivers
      - General cleanup and malloc/free issues fixed (Hartley Sweeten)
      - Generic FT2232 driver improvements for performance and
        stability (Arnim Laeuger)
      - New FT2232 based cable BFIN-UJTAG/gnICE (Michael Hennerich)
      - New Segger J-Link driver (not really functional yet) (Kolja Waschk)
      - Xilinx XPCU cable driver now using fast GPIF transfers via vendor
        request instead of bit banging (Kolja Waschk)
    * Updated flash drivers
      - Fix address shift (Jeff Wittrock)
      - Fixes and better verbosity in flash drivers (Jie Zhang)
    * Added new JTAG declarations for
      - Analog Devices Blackfin BF527 (Jie Zhang)
      - Atmel ATF1504ASV (Stefan Pledl)
      - Atmel AT32AP7000 (Gabor Juhos)
    * Updated documentation

urjtag-0.8

    * Integrated BSDL parser (Arnim Laeuger)
    * Updates to the jtag command shell
      - New "bsdl" command
      - New "scan" command
      - More flexible search algorithm for "include" and "script"
    * New and updated bus drivers
      - Added prototype bus driver (Detrick Martin)
      - Added bus drivers for various Blackfin boards (Jie Zhang)
      - Improvements in S3C4510B driver
    * New and updated cable drivers (by A. Laeuger, unless noted otherwise)
      - Wiggler driver with configurable pin mapping 
      - TRST/SRST and LED support in drivers for FT2232-based cables
      - Vision EP9307 GPIO (Hartley Sweeten)
      - Added new variants of FT2232-based cables
        - Amontec JTAGkey (Laurent Gauch)
        - OOCDLink-s
        - Turtelizer 2
        - USB to JTAG Interface
        - Xverve DT-USB-ST Signalyzer Tool
    * Numerous internal improvements
      - activity queuing mechanism to speed up JTAG over USB
      - simplified source directory layout; incorporated libbrux and inclow
      - (hopefully) fixed problem with writing to dual-mode x8/x16 flash
      - experimental (debug-only) new improved JEDEC flash detection
      - improved linking with USB drivers in Cygwin environment
      - several bug fixes and optimizations
    * Added new JTAG declarations for
      - Altera EP2C8 (Hartley Sweeten)
      - Analog Devices Blackfin BF537, BF549, BF567 (Jie Zhang)
      - Freescale MPC5241
      - Xilinx XC2V80- XC2V250- and XC2V1000-FG256 (Alexander Didebulidze)
    * Improved documentation
	* Added JIM, a cable/part simulator for regression testing and demos

urjtag-0.7 (2007-12-23)

Also see libbrux/NEWS for more news, especially regarding the flash support.

    * Integrated SVF player (Arnim Laeuger)
    * Updates to the jtag command shell
      - New writemem command to write to SRAM (Kent Palmkvist)
      - New debug, test and shell commands, aliasing for parts
      - Version output includes subversion revision number
      - New command line options "version","help","norc"
      - Improved diagnostics for bsdl2jtag, SVF player (Hein Roehrig)
      - More error messages added to cmd/bit.c (Jerome Debard)
      - More verbose output during flashmem (Jerome Debard)
      - DR can be loaded interactively (Martin Buck)
      - JTAG commands now parsed case insensitive (Andrew Dyer)
    * New and updated bus drivers
      - Added optional 'init' function to every bus driver
      - Analog Devices Blackfin BF533  (Robin Getz)
      - Analog Devices SHARC ADSP-21065L (Girish G.Pai,Lesly A.M,T.Nadackal,S.Abraham)
      - Freescale MPC5200 (Asier Llano Palacios)
      - IBM PPC405EP (Wojtek Kaniewski)
      - Intel PXA2x0 (Cliff Brake, F.Rysanek)
      - JOP.design Cyclone boards (Arnim Laeuger)
      - Magnachip H7202 (Arnim Laeuger)
      - Updated Samsung S3C4510 bus driver (Krysztof Blaszkowski)
      - SLS Corp. UP3 (Kent Palmkvist)
      - Zefant XS3 (Arnim Laeuger)
    * New and updated cable drivers
      - Cable command syntax changed to allow better integration of
        non-parport-based cables (Laurent Pinchart)
      - Added support for FreeBSD ppi interface
      - Altera USB-Blaster and ixo.de usb_jtag (Kolja Waschk)
      - EJTAG driver (Oleg)
      - FT2232-based USB cables (Arnim Laeuger)
      - IGLOO cable (Robin Getz)
      - Xilinx Platform Cable USB (experimental) (Kolja Waschk)
      - Fix for certain Wiggler cables (David Vrabel)
      - Better diagnostics when opening ppdev (Hein Roehrig)
    * Improved documentation:
      - New doc/UrJTAG.txt
      - Added man pages for jtag and bsdl2jtag
    * Miscellaneous enhancements and fixes
      - Improved timing and busy-loop waiting (Hein Roehrig)
      - bidir support in bsdl2jtag (Wojtek Kaniewski)
      - GCC4 Compilation fix (Asier Llano Palacios)
      - Moved "libbrux" and "include" into jtag directory.
    * Added new JTAG declarations for
      - ADMtek ADM5120
      - Altera EP1C6, EP1C12, EPM3064
      - Analog Devices BF533, ADSP-21065L
      - Atheros AR2312
      - Atmel AT91SAM7S256
      - Brecis MSP2006
      - Freescale MPC5200
      - Hitachi AR7300
      - IBM PPC405EP
      - Intel PXA270
      - Lattice LC4128C
      - Lexra LX5280
      - Sharp LH7A400
      - Xilinx XC18V04, XC2C256, XC2C64, xC2S200E, XC2S300E, XC3S..., XCF04S, XC9572XL

jtag-0.6 (2007-11-02, never released officially; many derivatives in the wild)
  
    * Created UrJTAG fork at http://www.urjtag.org
    * Added new JTAG declarations for
        - Hitachi HD64465
        - Hitachi SH7729 (Beregnyei Balazs)
        - Motorola MPC8245
        - Broadcom BCM4712 (partial, Alan Wallace)
        - Xilinx XCR3128XL-VQ100 (patch 1010714, Michael Lauer)
        - Xilinx XCR3032XL-VQ44 (patch 972621, Andrew Dyer)
        - Toshiba TX4925/TX4926 (patch 972621, Andrew Dyer)
        - Sharp LH7A400 (patch 886068, Marko Rößler)
        - IBM 440GX (patch 1012120, Jerome Debard)
        - Lattice LC4032V (patch 1012120, Jerome Debard)
        - Lattice M4A3-64/32 (patch 1012120, Jerome Debard)
        - Lattice M4A3-256/192 (patch 1012120, Jerome Debard)
    * Added new bus drivers:
        - Motorola MPC824x
        - AMD Alchemy Solutions Au1500 (patch 853883, Zhang Wei)
        - Toshiba TX4925 (patch 972625, Andrew Dyer)
        - IBM PowerPC 440GX (patch 1012154, Jerome Debard)
        - Sharp LH7A400 (patch 886068, Marko Rößler)
    * Added support for Lattice Parallel Port JTAG Cable (patch 1012138, Jerome Debard).
    * Fixed pin assignment for Macraigor Wiggler JTAG Cable (patch 1040199, Andrew Dyer).
    * Added new commands:
        - 'salias' to define alias for a signal
        - 'reset' to reset JTAG chain
    * Explicit 'detectflash' command call is required before 'flashmem' command.
    * Fixed minor bugs (including bug 857039).
    * Fixed compiler error on Debian Woody (patch 986414, Martin Buck).
    * Added support for different Intel IXP425 frequency variants (patch 1030647, Trevor Man).
    * Rewritten and improved startup sequence to distinguish between interactive invocation
        and stdin input (fixed bug 858535, thanks to Andrew Dyer for an idea).
    * Removed support for parameter '-' (stdin).
    * New translations:
        - French (Michel Robitaille)
        - Kinyarwanda (Steven Michael Murphy)

jtag-0.5.1 (2003-10-11):

    * Added new JTAG declarations for
        - Altera EP1C20F400 (Rojhalat Ibrahim)
        - Altera EPM7128AETC100 (Rojhalat Ibrahim)
    * Added additional checks for valid ByteBlaster cable connection and enabled all variants
		of the cable (patch 793313, Rojhalat Ibrahim).
	* Used real data bus width for data reading in PXA2x0, SA1110, and SH7727 bus drivers
		(based on patch 792591, thanks to Guennadi Liakhovetski).
	* Added 'initbus' command to allow dynamic bus driver loading.
	* Added support for flashes with multiple block erase regions for 'flashmem' (Bradley D. LaRonde).
	* Added BOOT_DEF register emulation for PXA2x0 bus driver.
	* Fixed inverted TRST signal for Macraigor Wiggler JTAG Cable see patch 799377 for more info,
		thanks to Mike Tesch for reporting).
	* Added Ka-Ro TRITON (PXA255/250) JTAG Cable driver (patch 805103, Andreas Mohr).
	* Spelling and documentation fixes (patch 805108, Andreas Mohr).
	* Fixed minor bugs.
	* Updated translations:
		- Slovak

jtag-0.5 (2003-08-19):

	* Fixed bug with SELECT, AUTOFD, and STROBE signals handling (bug 745824).
	* Added new commands 'peek' and 'poke' (patch 747447, Matan Ziv-Av).
	* Fixed bugs in SH7727 bus driver (thanks to Rainer Dörken).
	* Added bus drivers for Hitachi SH7750R and Broadcom BCM1250 (patch 753300, Matan Ziv-Av).
	* Added bus driver for Hitachi SH7751R (patch 773533, Matan Ziv-Av).
	* Added bus width detection using MD3 and MD4 signals in SH7727 bus driver
		(thanks to Rainer Dörken).
	* Changes in 'discovery' command:
		- removed explicit JTAG chain length detection (patch 753298, Matan Ziv-Av)
		- simplified output messages
		- removed support for report results to file
	* Added new command 'part', syntax changes for 'set', 'get', 'dr', 'instruction', and
		'print' commands.
	* Added support for multiple buses, added new 'bus' command to change active bus.
	* Added initial JTAG declarations for Broadcom BCM3310 (see support request 770145 for
		more info, thanks to Ramses VI).
	* Added JTAG declarations for Samsung S3C4510B (Jiun-Shian Ho).
	* Added bus driver for Samsung S3C4510X (Jiun-Shian Ho).
	* Fixed invalid memory allocation size (core dump) in jtag_parse_line() function.
	* Added new 'include' command.
	* Added new commands 'signal', 'register', 'bit', and enhanced 'instruction' command
		to allow create JTAG declarations from command line (or script).
	* Added new 'eraseflash' command (patch 772267, Thomas Fröhlich).
	* JTAG declarations are now executed as scripts.
	* Added support for parts without IDCODE instruction.
	* Added support for "downto" in bit vectors and "observe_only" into bsdl2jtag
		(patch 787346, Brad Parker).
	* Minor bugs fixed.
	* New translations:
		- Slovak

jtag-0.4 (2003-05-29):

	* Added support for executing scripts directly from stdin (parameter '-').
	* Disabled external bus cycles for PXA250 for addresses above 0x04000000.
	* Fixed bug in BUSY signal handling in Linux ppdev driver.
	* Optimized bus drivers to increase bus access speed (readmem, flashmem, ...).
	* Added new command 'endian' to configure access mode to external files.
	* Added JTAG declarations for
		- Broadcom BCM5421S (patch 743129, Matan Ziv-Av)
		- DEC SA1100 (thanks to Jachym Holecek)
	* Added bus driver for Hitachi SH7727 (based on patch 743140, Matan Ziv-Av).
	* Added support for printing current JTAG frequency.
	* Added support for 'signal' keyword (as alias for 'pin') into JTAG declarations.
	* Minor bugs fixed.

jtag-0.3.2 (2003-04-04):

	* Added driver for Keith & Koep JTAG Cable.
	* Ported to NetBSD/i386 (Jachym Holecek).
	* Added JTAG declarations for Xilinx XCR3256XL-FT256 (Jachym Holecek).

jtag-0.3.1 (2003-03-19):

	* Added support for Intel PXA255 A0 (thanks to Mike Sprauve).
	* Added support for running scripts specified as jtag command line parameters.
	* Added support for comments in scripts. Lines started with `#' are treated as
		comments.
	* Added support for Linux ppdev parallel port driver. Non-root users can
		use JTAG Tools now.
	* Added new `bsdl2jtag' conversion tool (Matan Ziv-Av).

jtag-0.3 (2003-02-25):

	* Changes in interactive commands:
		- enhanced 'dr' command functionality
		- new 'set signal' command
		- new 'get signal' command
		- new 'script' command (Alessandro Zummo)
	* Added support for JTAG cables:
		- Mpcbdm JTAG Cable (Christian Pellegrin)
		- Arcom JTAG Cable (patch 682310, Ian Campbell)
	* Added JTAG declarations for
		- Intel IXP425 (Christian Pellegrin)
		- Xilinx XC2C256-TQ144 (Alessandro Zummo)
		- Broadcom BCM1250 (Matan Ziv-Av)
		- Hitachi SH7727 (Matan Ziv-Av)
	* Added bus driver for Intel IXP425 (Christian Pellegrin).
	* Added support for all 6 static memory banks for Intel SA1110 (bug 682660).
	* Added support for bidirectional 'B' boundary scan bits (Christian Pellegrin).
	* Added support for 1 x 16 bit memory configuration (Christian Pellegrin).
	* Added buffered file reads/writes (Christian Pellegrin).
	* Added support for flash drivers (August Hörandl).
	* Added flash driver for AMD chips (August Hörandl).
	* Added support for rc and history files (Alessandro Zummo).
	* Added support for localization.
	* Some bugs fixed.

jtag-0.2.2 (2003-02-04):

	* Added new manufacturer: Cypress. (patch 669157, Chris Ellec)
	* Added new 'frequency' command to limit maximum TCK frequency
	* Added support for parallel ports with I/O addresses above 0x3FF

jtag-0.2.1 (2003-01-13):

	* Fixed compile error (bug 665923, thanks to Chris Ellec).
	* Added support for Macraigor Wiggler JTAG Cable (Stas Khirman).
	* Added support for Altera ByteBlaster/ByteBlaster II/ByteBlasterMV
		Parallel Port Download Cable.
	* Fixed some other bugs.

jtag-0.2 (2003-01-08):

	* Completed JTAG declarations for Xilinx XCR3128XL-CS144.
	* Fixed crash if flash memory is not detected.
	* Added new 'discovery' command for discovery unknown JTAG chains.
	* Added JTAG cable driver support and new 'cable' command.

jtag-0.1 (2002-11-25):
	
	* Initial public release.
